Attribute VB_Name = "Module1"

Option Explicit
Option Base 1                   ' Set default array subscripts to 1.
Public Type POINT_API
                X As Long
                Y As Long
          End Type
Public lpPoint As POINT_API                   ' Pointer for API call
Public LLGLineTo As Long                       ' Used in API LineTo call

Public Declare Function timeGetTime Lib "winmm.dll" () As Long
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINT_API) As Long


Public arrTREND1(800) As Single        ' Array holding raw data for Trend 1
Public arrTREND2(800) As Single         ' Array holding raw data for Trend 2
Public arrTREND3(800) As Single        ' Array holding raw data for Trend 3
Public arrTREND4(800) As Single        ' Array holding raw data for Trend 4
Public arrTREND5(800) As Single        ' Array holding raw data for Trend 5
Public arrTREND6(800) As Single        ' Array holding raw data for Trend 6

Public TempArray1(800) As Single           ' Used during freezing
Public TempArray2(800) As Single           ' Used during freezing
Public TempArray3(800) As Single           ' Used during freezing
Public TempArray4(800) As Single           ' Used during freezing
Public TempArray5(800) As Single           ' Used during freezing
Public TempArray6(800) As Single           ' Used during freezing

Public Snap1TREND1(800) As Single        ' Array holding snapped data for Trend 1
Public Snap1TREND2(800) As Single         ' Array holding snapped data for Trend 2
Public Snap1TREND3(800) As Single        ' Array holding snapped data for Trend 3
Public Snap1TREND4(800) As Single        ' Array holding snapped data for Trend 4
Public Snap1TREND5(800) As Single        ' Array holding snapped data for Trend 5
Public Snap1TREND6(800) As Single        ' Array holding snapped data for Trend 6

Public Snap2TREND1(800) As Single        ' Array holding snapped data for Trend 1
Public Snap2TREND2(800) As Single         ' Array holding snapped data for Trend 2
Public Snap2TREND3(8400) As Single        ' Array holding snapped data for Trend 3
Public Snap2TREND4(800) As Single        ' Array holding snapped data for Trend 4
Public Snap2TREND5(800) As Single        ' Array holding snapped data for Trend 5
Public Snap2TREND6(800) As Single        ' Array holding snapped data for Trend 6
Public Alpha As Long                                ' Used for Time Scrolling of traces

Public DataValue(6) As Single             ' Array holding received data for6 channels
Public PicAddress(6) As Single           ' Array holding Pic address to scan
Public BitAddress(6) As Byte                ' Array holding Bit address for dataline
Public ByteBits(6) As Byte                  ' Array holding Rx byte containing the bit
Public DataType(6) As Integer              ' Scan data type 1=bite,2=byte,3=word,4=Fpoint
Public DataWatchDog(6) As Boolean   ' Comms Watchdogs for 6 channels
Public RxChannel As Integer                ' Current channel receiving
Public Y_Shift(6) As Integer                ' Array holding trace shift-values
Public X_Gain(6) As Single                 ' Array holding trace gain-values
Public EXIT_Flag As Boolean              ' Set when exit from trace screen
Public CmdBank2 As Boolean            ' Set when writing to PIC address in Bank 3 or 4
Public ReadBank2(6) As Boolean        ' Set when reading from PIC address in Bank 3 or 4

Public CommReq As Boolean             ' Flag indicating command waiting to be Tx'ed
Public CommString As String             ' Command message to PIC

Public X_Width As Integer                   ' Holds Width of trace screen
Public Y_Height As Integer                  ' Holds Height of trace screen
Public TraceSnap(6) As Single             ' Trace values at snapshot position
Public SnapIndex As Integer                ' Index value at snapshot time
Public Current_X As Integer                  ' Array  index value for cursor line when
                                                              ' ...display showing scanning data
Public X_Position As Integer                ' Array index value for cursor line when
                                                            ' ....display showing freeze data
Public ScanSpeed As Single                ' Scan time for 20 cycles
Public ScanRate As Single                  ' Average scanrate over 20 cycles
Public ScanBusy As Boolean              ' Flag indicating busy with data scan
Public TxDelay As Long                      ' Delay between tx'ing bytes
Public FreezeFlag As Boolean             ' Set when viewing freezed trace screen
Public CommsActive As Boolean         ' Set once Comm port selected

Public TimeCount1 As Long                       ' For timing measurement
Public TimeCount2 As Long                       ' For time measurement
Public TimeCount3 As Long                       ' For delay between byte tx

Public Exp As Byte                                  ' For FPoint conversion
Public MntB0 As Byte                               ' ..........
Public MntB1 As Byte                               ' ..........

Public FBackValue As Single                     ' Holds command feedback value
Public CommandF_Back(4) As Boolean    ' Flag indicating for which command
                                                                 '  must we scan for a Pic value
Public CommandIndex As Integer            '  Holds index of command block requiring feedback
Public FeedBackReq As Boolean              ' Flag indicating Command Block feedback required
Public FeedBackReqActive As Boolean    ' Flag indicating serial port handler issued
                                                                  ' a Command Feedback message to PIC
Public FBackAddr As Single                      ' Holds address of command feedback value
Public FBackDataType As Integer             ' Holds data type of command feedback value
                                                                  '  ...1=bit,2=byte,3=word,4=Fpoint
Public FBackBitNr   As Byte                      ' Holds bit nr of command feedback value
Public ScanToShort As Boolean               ' Set when required scanrate is set to fast
Public CommsFail As Boolean                    ' Set when Rx data time out
Public PICReplied As Boolean                    ' Set when PIC answered
                                                                 

' Section for Fuzzy stuff
' Example of fuzzy things:
'       Let x be a linguistic variable with the label AGE. Terms of this linguistic
'       variable, (which are fuzzy sets), could be OLD, YOUNG, VERY-OLD, ect.,
'       and the set of terms T could be defined as
'           T(AGE) = (OLD, VERY-OLD, NOT-SO-OLD, MORE-OR-LESS-YOUNG'
'                           QUITE-YOUNG, VERY-YOUNG)

Public INPUT_NAMES(0 To 3) As String             ' Declare Data Base for the Names/Labels of the 4 Inputs
                                                                ' ....linguistic variables like TEMPERATURE, SPEED, FLOW, etc.
Public OUTPUT_NAMES(0 To 1) As String         ' Declare Data Base for the Names/Labels of the 2 Outputs
                                                                ' ...linguistic variables like VALVE-POSITION, PID-OUT, etc.
Public FUZZY_NAMES(0 To 23) As String           ' Declare Data Base for the Names/Labels (i.e. HOT, HIGH, FAST) of the terms (Fuzzy Sets) for each input
                                                                ' .... For each of the 4 inputs there are 6 Fuzzy Sets.
Public DegreeOfMember(0 To 23) As Integer       ' Declare Data Base for Membership values. The current value of a liguistic variable, input,
                                                                ' .... will belong to a fuzzy set to a degree.
Public OUT_TERMS(0 To 11) As String                ' Declare Data Base for up to 6 linguistic terms (i.e. INCR_FAST, HIGH-POWER, etc.)
                                                                ' ... for each of the two outputs.
Public OUT_TERM_WEIGHT(0 To 11) As Integer   ' Declare Data Base for Output Singletons
Public OUT_TERM_VALUE(0 To 11) As Integer   ' Declare Data Base for Output Singletons values from Inference Engine
Public FUZZY_SETS(0 To 95, 0 To 1) As Integer         ' Declare Data Base for Fuzzy Sets. Each input has 6 membership functions, with each
                                                                ' ... function being user-defined by 4 parameters: X1, X2, X3, X4 (trapezium)
                                                                ' ... The 2nd column is calculated from the 1st and contains the 4 parameters:
                                                                ' ... X1, Slope1, X2, Slope2. These are used to calculate u (degree of membership)
Public InputValue(0 To 3) As Integer                  ' For holding the values of the 4 linguistic variables
Public OutputValue(0 To 1) As Integer               ' For holding the 2 output values.
Public RuleBase(0 To 299) As Integer                 ' Each rule is specified using 6 parameters
                                                                ' if   A   is  X  AND  B  is  Y  THEN  OUTx = Z
                                               ' Field Nr:          1       2           3       4               5        6
                                                                ' Field contents:   -1  = No item selected
                                                                '                          0  = 1st item selected
                                                                '                          1  = 2nd item selected
                                                                '                       etc.......
                                                ' Field content interpretation:
                                                                ' Field Nr.1 and 3:    Range:       -1, 0, 1, 2, 3.
                                                                '                             Purpose:    Specifies which one of the 4 Inputs to use.
                                                                ' Field Nr. 2 and 4:   Range:       -1, 0, 1, 2, 3, 4, 5.
                                                                '                             Purpose:    Specifies which one of the fuzzy terms, up to 6 fuzzy set per
                                                                '                                              Input, to use.
                                                                ' Field Nr.5:             Range:       -1, 0, 1
                                                                '                             Purpose:    Specifies which one of the two Outputs to use.
                                                                ' Field Nr.6              Range:       -1, 0, 1, 2, 3, 4, 5.
                                                                '                             Purpose:    Specifies which one of the fuzzy terms, up to 6 fuzzy set per
                                                                '                                              Output, to use.
Public PICFuzzIn(4) As Boolean        ' Set when reading input data from PIC
Public FuzzAutoCom1 As Boolean   ' Set when auto request for Fuzzy command 1
Public FuzzAutoCom2 As Boolean   ' Set when auto request for Fuzzy command 2
Public AutoCommString1 As String   ' String holding Fuzzy Command 1
Public AutoCommString2 As String   ' String holding Fuzzy Command 2
Public AutoToggle As Boolean          ' Flag for regulating alternate auto commands


Public Sub DisplayCurrent(Num1 As Single, Num2 As Single, Num3 As Single, Num4 As Single, _
                                    Num5 As Single, Num6 As Single)
    ' Display numeric values of active traces on trend picture screen
    ' Input:    Num1    = Value for trace 1
    '             Num 2   = Value for trace 2
    '             Num 3   = Value for trace 3
    '             Num 4   = Value for trace 4
    '             Num 5   = Value for trace 5
    '             Num 6   = Value for trace 6
                 
    Dim Y_Place As Long
            frmTREND3.Picture3.Cls                              ' Clear window for cursor display values
            Y_Place = 10                                               ' Y ordinate to start print at
            If frmTREND3.chkShowTrace(1).Value = 1 Then
                PrintNumeric frmTREND3.Picture3, 1, Y_Place, Num1, "", " ", vbWhite        ' Display trace 1 numeric value
                Y_Place = Y_Place + 150                         ' Next print position
            End If
            
            If frmTREND3.chkShowTrace(2).Value = 1 Then
                PrintNumeric frmTREND3.Picture3, 1, Y_Place, Num2, "", " ", vbMagenta     ' Display trace 2 numeric value
                Y_Place = Y_Place + 150                         ' Next print position
            End If
            
            If frmTREND3.chkShowTrace(3).Value = 1 Then
                PrintNumeric frmTREND3.Picture3, 1, Y_Place, Num3, "", " ", vbYellow       ' Display trace 3 numeric value
                Y_Place = Y_Place + 150                          ' Next print position
            End If
            
            If frmTREND3.chkShowTrace(4).Value = 1 Then
                PrintNumeric frmTREND3.Picture3, 1, Y_Place, Num4, "", " ", vbRed            ' Display trace 4 numeric value
               Y_Place = Y_Place + 150                         ' Next print position
            End If
            
            If frmTREND3.chkShowTrace(5).Value = 1 Then
                PrintNumeric frmTREND3.Picture3, 1, Y_Place, Num5, "", " ", vbCyan            ' Display trace 5 numeric value
               Y_Place = Y_Place + 150                         ' Next print position
            End If
   
            If frmTREND3.chkShowTrace(6).Value = 1 Then
                PrintNumeric frmTREND3.Picture3, 1, Y_Place, Num6, "", " ", vbGreen            ' Display trace 6 numeric value
            End If
   
End Sub



Public Sub ByteCopy(oldCopy() As Byte, newCopy() As Byte)
   newCopy = oldCopy
End Sub

Public Function BinC(Number As Byte) As String
    ' Convert a number into its binary string representation
    ' with space separating nibbles.
    Dim i As Integer
    Dim BinS As String
    For i = 7 To 0 Step -1
        If Number And (2 ^ i) Then
            BinS = BinS + "1"
        Else
            BinS = BinS + "0"
        End If
        If i = 4 Then BinS = BinS + " "
    Next i
    BinC = BinS
End Function

Public Sub CopyArry(oldCopy() As Single, newCopy() As Single)
    newCopy = oldCopy
End Sub

Public Sub PrintNumeric(Picture As PictureBox, X As Long, Y As Long, Number As Single, FrontString As String, _
                                    BackString As String, Color As Long)
    ' Print numeric values on trend screen with front and
    ' back strings added
    ' X, Y             =  is print start cooordinates
    ' Number        = Numeric value to print
    ' FrontString   = String to print in front of number
    ' Backstring    = String to append at back of number
    
       Picture.CurrentX = X:    Picture.CurrentY = Y
       Picture.ForeColor = Color
      Picture.Print FrontString & Format(Number, "####0.0###") & BackString
End Sub

Public Function Byte2Float(Exp As Integer, B0 As Integer, B1 As Integer) As Double
    ' Function to convert 3 bytes into floating point representation. See
    ' MICROCHIP AN575 for details of 24Bit floating point format.
    Dim TempB0 As Single
    
    TempB0 = CSng(B0)                               ' Conversion to prevent overflow
    If B0 > 127 Then                                     ' If MSBit set then nr is -ve
        Byte2Float = -2 ^ (Exp - 127) * ((TempB0 * 256 + B1) / 32768)
    Else
        Byte2Float = 2 ^ (Exp - 127) * (((TempB0 * 256 + B1) + 32768) / 32768)
    End If
End Function


Public Sub Dec2PICFloat(Number As Single)
    ' Convert Number (as Single) to 3 bytes in MICROCHIP 24Bit representation
    '  where:
    '               Exp = Exponent
    '               B0  = MSByte of mantissa
    '               B1 = LSByte of mantissa
    Dim Z As Single
    Dim X As Single
    Dim E As Integer
    Dim Flag As Boolean
    
    If Number = 0 Then
        Exp = 0:    MntB0 = 0: MntB1 = 0                 ' Return representation for zero
    Else
        ' Check and handle negative number
        If Number < 0 Then
            Number = Abs(Number)
            Flag = True                                             ' Set flag indicating -ve number
        Else
            Flag = False
        End If
        Z = Log(Number) / Log(2)                            ' .... 2^Z = Number
        E = Int(Z)
        X = Number / (2 ^ E)                                   ' .... Number = X*2^E, where X is fraction
        ' Now manipulate E and X such that we get the
        ' number in the following form:
        '               Number = 1.xxxxxxx * 2^E
        While X < 1
            X = X * 2                                             ' Shift left
            E = E - 1                                            ' Adjust exponent
        Wend
        
        X = (X - 1) * 2 ^ 15                                   ' Notice hidden bit!!!!!
        MntB0 = Int(X / 256)                                ' B0 = the high byte
        MntB1 = Int(X Mod 256)                           ' B1 = the low byte
        
        If Flag Then MntB0 = MntB0 Or &H80      ' If -ve set MSBit
        Exp = E + 127                                       ' Bias the exponent
    End If
        
End Sub

Public Function Between(Value As Variant, LessThan As Integer, MoreThan As Integer) As Boolean
    ' This function will return True if MoreThan<Value<LessThan
    If Value < LessThan And Value > MoreThan Then
        Between = True
    Else
        Between = False
    End If
End Function

Public Sub RotateArray(TrendArray() As Single, Value As Single)
' Rotate trend raw data array one place left and insert Value on right
    Dim X As Integer
    For X = 1 To 799
        TrendArray(X) = TrendArray(X + 1)
    Next X
    TrendArray(800) = Value
End Sub

Public Sub DrawTrace(TrendArry() As Single, TraceNr As Integer, TraceColor As Long)
    ' This subroutine will draw a trace on the display window
    ' Input:
    '           TrendTrace()    = Array holding Trace data - 400 points
    '           TraceNr           = Number of trace 1....5
    '           TraceColor      =  Color used for trace
    
        Dim Y_50 As Integer                                  ' Holds 50% y-value
        Dim X As Integer
        Dim X_IncSize As Single                            ' Holding size of x-increment
        Dim X_Ordinate As Integer                          ' Holds current X value
        Dim Y_Ordinate As Long
    If frmTREND3.chkShowTrace(TraceNr).Value = Checked Then        ' Check if trace selected for display
            frmTREND3.Picture1.ForeColor = TraceColor                         ' Set Line color
            Y_50 = Y_Height / 2 + Y_Shift(TraceNr)
            X_IncSize = X_Width / 400                      ' Calculate X increment size
            
             ' Set trace start-point at right of picture box.
             LLGLineTo = MoveToEx(frmTREND3.Picture1.hdc, X_Width, Y_50 - (X_Gain(TraceNr) * TrendArry(400 + Alpha)), lpPoint)
             

           ' And now we draw the trace from right to left.
             For X = 399 To 1 Step -1
                X_Ordinate = X_IncSize * X
                ' Calculate value of y, but limit it to viewport
                Y_Ordinate = Y_50 - (X_Gain(TraceNr) * TrendArry(X + Alpha))
                    If Y_Ordinate < 1 Then
                        Y_Ordinate = -1
                    End If
                LLGLineTo = LineTo(frmTREND3.Picture1.hdc, X_Ordinate, Y_Ordinate)
             Next X
        End If
End Sub



' Fuzzy things

Public Sub ShowRule(RuleNr As Integer)
   Dim iCount As Integer
   Dim Index As Integer
   
   Index = 6 * (RuleNr - 1)
    ' Display the names of the 4 Inputs in 1st and 2nd Variable listboxes
    With Form3
        For iCount = 0 To 3
             .lstVariable1.List(iCount) = INPUT_NAMES(iCount)
             .lstVariable2.List(iCount) = INPUT_NAMES(iCount)
         Next iCount
    
    ' Display the names of the 2 Outputs in output listbox
        For iCount = 0 To 1
            .lstOutput.List(iCount) = OUTPUT_NAMES(iCount)
        Next iCount
    
.lstVariable1.ListIndex = RuleBase(Index)           ' Highlight the Input selected
.lstTerm1.ListIndex = RuleBase(Index + 1)          ' Highlight membership function selected
.lstVariable2.ListIndex = RuleBase(Index + 2)      ' Highlight the Input selected
.lstTerm2.ListIndex = RuleBase(Index + 3)           ' Highlight membership function selected
.lstOutput.ListIndex = RuleBase(Index + 4)          ' Highlight the Output selected
.lstOutTerms.ListIndex = RuleBase(Index + 5)     ' Highlight membership function selected

    ' Read the Fuzzy Set Names (for the selected Input Variable) from the data base
    ' ...and display it in Rule Editor TERM1 window (if an Input is selected)
        For iCount = 0 To 5
            If .lstVariable1.ListIndex <> -1 Then
                .lstTerm1.List(iCount) = FUZZY_NAMES((6 * .lstVariable1.ListIndex) + iCount)
            Else: .lstTerm1.List(iCount) = ""
            End If
        Next iCount
    
    ' Read the Fuzzy Set Names (for the selected Input Variable) from the data base
    ' ...and display it in Rule Editor TERM2 window (if an Input is selected)
        For iCount = 0 To 5
            If .lstVariable2.ListIndex <> -1 Then
                .lstTerm2.List(iCount) = FUZZY_NAMES((6 * .lstVariable2.ListIndex) + iCount)
            Else: .lstTerm2.List(iCount) = ""
            End If
        Next iCount

    ' Read the Fuzzy Set Names (for the selected Output Variable) from the data base
    ' ...and display it in Rule Editor Output TERM window (if an Output is selected)
        For iCount = 0 To 5
            If .lstOutput.ListIndex <> -1 Then
                .lstOutTerms.List(iCount) = OUT_TERMS((6 * .lstOutput.ListIndex) + iCount)
            Else: .lstOutTerms.List(iCount) = ""
            End If
        Next iCount

    End With
End Sub

Public Sub Draw_a_Term(X_Points As Object, Color As Integer)
' Procedure to draw a trapezium-like figure with the
' 4 parameters passed as points on the X-axis
    Dim XA As Integer
    Dim XB As Integer
    XA = (20 * Val(X_Points(0))) + 360
    XB = (20 * Val(X_Points(1))) + 360
        ' Draw 1st line (X1 to X2)
        Form2.Picture1.Line (XA, 1140)-(XB, 220), QBColor(Color)
    XB = (20 * Val(X_Points(2))) + 360
        ' Draw 2nd line (X2 to X3)
        Form2.Picture1.Line -(XB, 220), QBColor(Color)
    XB = (20 * Val(X_Points(3))) + 360
        ' Draw 3rd line (X2 to X3)
        Form2.Picture1.Line -(XB, 1140), QBColor(Color)
End Sub

Public Sub DrawTerms()
   Form2.Picture1.Cls
  Call Draw_a_Term(Form2.txtX1_1(), 15)
  Call Draw_a_Term(Form2.txtX2_1(), 14)
  Call Draw_a_Term(Form2.txtX3_1(), 13)
  Call Draw_a_Term(Form2.txtX4_1(), 12)
  Call Draw_a_Term(Form2.txtX5_1(), 11)
  Call Draw_a_Term(Form2.txtX6_1(), 10)

End Sub

Public Sub MarkXposition(Term As Object, Index As Integer)
    ' Change the background colour so you can see which
    ' is the term currently selected for editing
    Dim A As Integer
     For A = 0 To 3
        If A = Index Then
            Term(Index).BackColor = &HC0C0C0    ' Mark selected field
       Else
            Term(A).BackColor = &HFFFFFF         ' Un-mark other fields
       End If
    Next A

End Sub

Public Sub ValidateTerm(Term As Object)
    ' Limit X-values to 0....255
    Dim i As Integer
    For i = 0 To 3
        If Term(i).Text > 255 Then Term(i).Text = 255
        If Term(i).Text < 0 Then Term(i).Text = 0
    Next i
End Sub

Public Sub XMonotone(Term As Object)
    ' Check that X-values always bigger than previous value
    If Val(Term(0)) > Val(Term(1)) Then Term(1) = Term(0)
    If Val(Term(1)) > Val(Term(2)) Then Term(2) = Term(1)
    If Val(Term(2)) > Val(Term(3)) Then Term(3) = Term(2)

End Sub

Public Sub CalcSetParams()
' #####################################################
' # This routine calculates the 4 parameters which define a fuzzy set
' # for each of the 24 Terms (4 linguistic input variables with each
' # having 6 Terms). The calculated parameters are also written
' # to the database.
' # The parameters are 1st -  X1
' #                              2nd - Slope1
' #                              3rd - X3
' #                              4th - Slope2
' # Results saved into array FUZZY_SETS
' #####################################################
Dim iCount As Integer
Dim jCount As Integer
Dim kCount As Integer
Dim Slope As Integer
Dim Index As Integer
For iCount = 0 To 3                     ' To handle the 4 input variables
    For jCount = 0 To 5                 ' To handle the 6 terms in each variable
        For kCount = 0 To 3             ' To handle the 4 parameters for each term
            Index = 24 * (iCount) + 4 * (jCount) + kCount
            Select Case kCount
                    Case 0
                        FUZZY_SETS(Index, 1) = FUZZY_SETS(Index, 0)     ' Write X1
                    Case 1
                        If FUZZY_SETS(Index, 0) - FUZZY_SETS(Index - 1, 0) = 0 Then
                            Slope = 255
                        Else
                            Slope = Int(0.5 + (255 / (FUZZY_SETS(Index, 0) - FUZZY_SETS(Index - 1, 0))))
                        End If
                        FUZZY_SETS(Index, 1) = Slope
                    Case 2
                        FUZZY_SETS(Index, 1) = FUZZY_SETS(Index, 0)     ' Write X2
                    Case 3
                        If FUZZY_SETS(Index, 0) - FUZZY_SETS(Index - 1, 0) = 0 Then
                            Slope = 255
                        Else
                            Slope = Int(0.5 + (255 / (FUZZY_SETS(Index, 0) - FUZZY_SETS(Index - 1, 0))))
                        End If
                        FUZZY_SETS(Index, 1) = Slope
            End Select
        Next kCount
    Next jCount
Next iCount
End Sub

Public Sub Fuzzify()
' ######################################################
' # Procedure to fuzzify.
' # Each crisp input value is applied to the 6 fuzzy sets of a linguistic variable.
' # This will produce a Degree-of-Membership value for each fuzzy set.
' ######################################################
Dim iCount As Integer
Dim jCount As Integer
Dim TermIndex As Integer
Dim uIndex As Integer
For iCount = 0 To 3                                     ' For the 4 input values
    For jCount = 0 To 5                                 ' For the 6 terms of each input
        TermIndex = 24 * iCount + 4 * jCount    ' Calculate index of current term
        uIndex = 6 * iCount + jCount                ' Calculate index of current membership value
        If InputValue(iCount) < FUZZY_SETS(TermIndex + 2, 1) Then     ' Test if input value < X3
            ' Calculate output using 1st section: y=(x-X1)*slope1
            ' ...If slope = 255 then y=255
            If FUZZY_SETS(TermIndex + 1, 1) = 255 Then              ' Test for no-slope
                DegreeOfMember(uIndex) = 255
            Else
                DegreeOfMember(uIndex) = (InputValue(iCount) - FUZZY_SETS(TermIndex, 1)) * FUZZY_SETS(TermIndex + 1, 1)
                If DegreeOfMember(uIndex) > 255 Then DegreeOfMember(uIndex) = 255
                If DegreeOfMember(uIndex) < 0 Then DegreeOfMember(uIndex) = 0
            End If
        Else
            ' Calculate output using 2nd section: y=255-((x-X3)*slope2)
            ' ...If slope = 255 then y=255
            If FUZZY_SETS(TermIndex + 3, 1) = 255 Then              ' Test for no-slope
                DegreeOfMember(uIndex) = 255
            Else
                DegreeOfMember(uIndex) = 255 - ((InputValue(iCount) - FUZZY_SETS(TermIndex + 2, 1)) * FUZZY_SETS(TermIndex + 3, 1))
                If DegreeOfMember(uIndex) < 0 Then DegreeOfMember(uIndex) = 0
            End If
        End If
    Next jCount
Next iCount
            End Sub

Public Sub InferenceEngine()
' This Inference Engine uses the Rule Base as input.
' For a description of the fields in the rule base see
' ...RuleBase in the Declarations section
Dim Item1, Item2, Item3, Item4, NotActive As Boolean
Dim Result1, Result2 As Integer
Dim iCount, jCount As Integer
' First we clear the engins Output values
' Remember there are two Outputs, each with 6 Terms
For iCount = 0 To 11
    OUT_TERM_VALUE(iCount) = 0
Next iCount
For iCount = 0 To 49                            ' For handling the 50 rules
    NotActive = False                            ' Set when one input not-active
    jCount = 6 * iCount                          ' Point to 1st item of Rule
    Item1 = (RuleBase(jCount) = -1 Or RuleBase(jCount + 1) = -1)
    Item2 = (RuleBase(jCount + 2) = -1 Or RuleBase(jCount + 3) = -1)
    Item3 = (RuleBase(jCount + 4) = -1 Or RuleBase(jCount + 5) = -1)
    If Not ((Item1 And Item2) Or Item3) Then              ' Ignore rule if not-active in both input items or any output item
        ' Compute 1st statement result
        If Item1 Then
            Result1 = 0
            NotActive = True
        Else
            Result1 = DegreeOfMember(6 * RuleBase(jCount) + RuleBase(jCount + 1))
        End If
        
           ' Compute 2nd statement result
        If Item2 Then
            Result2 = 0
            NotActive = True
        Else
            Result2 = DegreeOfMember(6 * RuleBase(jCount + 2) + RuleBase(jCount + 3))
        End If
        
        ' Now perform AND function between membership values
        ' Notice that if one of the inputs not used the we simply use the other value
        If NotActive = True Then
            If Result1 < Result2 Then Result1 = Result2             ' Take largest if one input not used
        Else
            If Result1 > Result2 Then Result1 = Result2             ' Take smallest if both inputs in use
        End If
        
     ' Compute output result for selected singleton
         jCount = 6 * RuleBase(jCount + 4) + RuleBase(jCount + 5)   ' Point to singleton position
        If OUT_TERM_VALUE(jCount) < Result1 Then                      ' If new calculated result > old result
            OUT_TERM_VALUE(jCount) = Result1                             ' ...then update result this singleton
        End If
    End If
Next iCount
End Sub

Public Sub DeFuzzify()
' Procedure to defuzzify the two outputs, The Centre-of-Gravity method is used
' Defuzzify Output1
Dim Num, Denom As Long
Dim iCount As Integer
Num = 0
Denom = 0
For iCount = 0 To 5
    Num = Num + CLng(OUT_TERM_VALUE(iCount)) * CLng(OUT_TERM_WEIGHT(iCount))
    Denom = Denom + OUT_TERM_VALUE(iCount)
Next iCount
If Denom = 0 Then
    OutputValue(0) = 0
Else
    OutputValue(0) = Num / Denom
End If

' Defuzzify Output2
Num = 0
Denom = 0
For iCount = 6 To 11
    Num = Num + (OUT_TERM_VALUE(iCount) * OUT_TERM_WEIGHT(iCount))
    Denom = Denom + OUT_TERM_VALUE(iCount)
Next iCount
If Denom = 0 Then
    OutputValue(1) = 0
Else
    OutputValue(1) = Num / Denom
End If
End Sub

Public Sub Draw_a_Singltn(Singleton As Integer, Val As Integer, Color As Integer)
    ' Singleton = X-value
    ' Val         = Y-value
    ' Color      = colour
    ' Draw a line on output graphic window representing a output Term.
    ' The X-value magnetude is the Singleton scalar value (the 'weight'), while the
    ' Y-value represents the max-value result (for the Singleton) resulting
    ' from the inference engine
    Dim XA As Integer
    Dim XB As Integer
    XA = (20 * Singleton) + 360
    XB = 1140 - (3 * Val)
        Form2.Picture2.DrawWidth = 6
        Form2.Picture2.Line (XA, 1140)-(XA, XB), QBColor(Color)
        Form2.Picture2.DrawWidth = 1
End Sub

Public Sub DrawOutData()
' Draw the inference results for selected output in 2nd graphic window
Dim Index As Integer
   Form2.Picture2.Cls
    Index = 6 * (Val(Form2.txtOutputNr.Text) - 1)
    Call Draw_a_Singltn(OUT_TERM_WEIGHT(Index), OUT_TERM_VALUE(Index), 15)
    Call Draw_a_Singltn(OUT_TERM_WEIGHT(Index + 1), OUT_TERM_VALUE(Index + 1), 14)
    Call Draw_a_Singltn(OUT_TERM_WEIGHT(Index + 2), OUT_TERM_VALUE(Index + 2), 13)
    Call Draw_a_Singltn(OUT_TERM_WEIGHT(Index + 3), OUT_TERM_VALUE(Index + 3), 12)
    Call Draw_a_Singltn(OUT_TERM_WEIGHT(Index + 4), OUT_TERM_VALUE(Index + 4), 11)
    Call Draw_a_Singltn(OUT_TERM_WEIGHT(Index + 5), OUT_TERM_VALUE(Index + 5), 10)

End Sub




Public Sub FuzzDisplay1(Index)
    ' When linguistic value is manually changed then update its:
    '       Numeric display
    '       X-value dotted line and value on fuzzy set graphic (if this input on display)
    
    Form2.txtOutValue = OutputValue(Val(Form2.txtOutputNr) - 1)     ' Update display with result
       If Val(Form2.txtInputNr.Text) = Index + 1 Then                           ' If change input is also on display then:
            Form2.lnInputValue.X1 = 360 + 20 * Form2.scrInVar(Index).Value  ' Update Input line on display
            Form2.lnInputValue.X2 = 360 + 20 * Form2.scrInVar(Index).Value  ' .......
            Form2.txtInValue = Form2.txtInVarValue(Index).Text                 ' Update Output value at line
            Form2.txtInValue.Left = 270 + 20 * Form2.scrInVar(Index).Value    ' Position Output value at line
            Call DrawTerms                                                     ' Update Terms graphic
    End If

End Sub


Public Sub FuzzDisplay2()
    ' Update position and value of output line
    ' on output graphic
    Form2.lnOutValue.X1 = 360 + 20 * Val(Form2.txtOutValue.Text)  ' Update Output line on display
    Form2.lnOutValue.X2 = 360 + 20 * Val(Form2.txtOutValue.Text)  ' .......
    Form2.txtGraph = Form2.txtOutValue                                        ' Update Output value at line
    Form2.txtGraph.Left = 270 + 20 * Val(Form2.txtOutValue.Text)    ' Position Output value at line

End Sub

Public Sub FuzzDisplay3()
    ' If the input (linguistic variable), of which the fuzzy sets are currently
    ' on display, is obtained from PIC then update' the following on graphic display
    '       Current numeric value of variable at indicator line
    '       Position of value as dotted line

     If Form2.scrInVar(Val(Form2.txtInputNr.Text) - 1).Enabled = False Then                   ' If values obtained from PIC
            Form2.lnInputValue.X1 = 360 + 20 * InputValue(Val(Form2.txtInputNr.Text) - 1)  ' Update Input line on display
            Form2.lnInputValue.X2 = 360 + 20 * InputValue(Val(Form2.txtInputNr.Text) - 1)  ' .......
            Form2.txtInValue = InputValue(Val(Form2.txtInputNr.Text) - 1)                          ' Update Output value at line
            Form2.txtInValue.Left = 270 + 20 * InputValue(Val(Form2.txtInputNr.Text) - 1)    ' Position Output value at line
    End If
    
            Call DrawTerms                                                     ' Update Terms graphic

End Sub

' Public Sub FuzzCommand1()
    ' Routine to initiate command transmision
    ' for Fuzzy System Output1
        ' Prepare command message (for byte, word, FPoint)
    ' according to data type and then set command Tx request flag.
    ' Comms handler will Tx command message at end of data scan.
'    Dim B0 As Byte
'    Dim B1 As Byte
'    Dim B2 As Byte
'    Dim B3 As Byte
'    Dim LLGTEST As Single
'    Dim Msg As String
'    Dim FCODE As Byte


  '  If cboComType(Index).Text = "byte" Then                                         ' If BYTE command
  '      ' Message = FF, NOB, FCODE, ADDRESS, VALUE
        
  '      If Val("&H" & (txtComAddr(Index).Text)) > &HFF Then                   ' Test for access to Bank3,4
  '          FCODE = 5 + 128                                                                  ' 5 and Bit8 set
  '      Else
  '          FCODE = 5                                                                            ' 5 and Bit8 clear
  '      End If
  '
  '      B0 = Val("&H" & (txtComAddr(Index).Text)) And &HFF                  ' Calculate Address byte
  '      B1 = Val(txtComValue(Index).Text)                                              ' Calculate Value byte
  '      CommString = Chr(255) & Chr(3) & Chr(FCODE) & Chr(B0) & Chr(B1)
  '      CommReq = True

' End Sub

Public Function ComposeAutoCommand(Index As Integer, Value As Byte) As String
        Dim B0 As Byte
        Dim B1 As Byte
        Dim FCODE As Byte
                    '       Compose Auto Command
                    If Val("&H" & (frmTREND3.txtComAddr(Index).Text)) > &HFF Then       ' Test for access to Bank3,4
                        FCODE = 5 + 128                                                      ' 5 and Bit8 set
                    Else
                        FCODE = 5                                                                ' 5 and Bit8 clear
                    End If
                    B0 = Val("&H" & (frmTREND3.txtComAddr(Index).Text)) And &HFF      ' Calculate Address byte
                    B1 = Value   ' Val(txtComValue(Index).Text)                                  ' Calculate Value byte
                    ComposeAutoCommand = Chr(255) & Chr(3) & Chr(FCODE) & Chr(B0) & Chr(B1)
End Function

Public Sub TxPicCommand(CommandString As String)
    ' Transmit a command to PIC. Return when completed
    ' The bytes of the command message is Tx'ed one-by-one
    ' with  delay between bytes. The command must be prepared
    ' into a string so we can extract the bytes from it.
    Dim i As Integer
    Dim TxByteValue As Byte
                        For i = 1 To Len(CommandString)
                                TxByteValue = Asc(Mid(CommandString, i, 1))
                                TxByte (TxByteValue)
                        Next i
End Sub

Public Sub TxByte(Data As Byte)
' Transmit a Byte and wait user defined delay
frmTREND3.MSComm1.Output = Chr(Data)
TimeCount3 = timeGetTime + TxDelay
Do While TimeCount3 > timeGetTime
Loop
End Sub

Public Function ProcRxData(DataTp As Integer, Bt1 As Integer, Bt2 As Integer, Bt3 As Integer, BtNr As Byte) _
                                            As Single
    ' Function to process the 3 bytes received from PIC to extract data value.
    ' Input:    DataTp  ---- Data type of Rx message, 1=Boolean, 2=Byte, 3=Word, 4=FloatingPoint
    '             Bt1        ---- 1st Byte of message
    '             Bt2        ---- 2nd Byte of message
    '             Bt3        ---- 3rd Byte of message
    '            BtNr       ---- Bit number in case of boolean value
    ' Return:   Data Value, Note when boolean data type value of 100 return if bit set, else 0
    Dim DataVal As Single

         Select Case DataTp
                '--------------------------------------------------------------------------------------------------------------
                Case 1                                         ' Process as Bit data-type
                '--------------------------------------------------------------------------------------------------------------
                        If (Bt1 And (2 ^ BtNr And &HFF)) > 0 Then
                            DataVal = 100                            ' Value for trending purpose = 100 if bit set
                        Else
                            DataVal = 0                                ' Value for trending purpose = 0 if bit clear
                        End If
                '--------------------------------------------------------------------------------------------------------------
                Case 2                                         ' Process as Byte data-type
                '--------------------------------------------------------------------------------------------------------------
                        DataVal = Bt1                      ' Value of 1st byte Rx'ed
                
                 '--------------------------------------------------------------------------------------------------------------
                Case 3                                         ' Process as Word data-type
                 '--------------------------------------------------------------------------------------------------------------
                        Dim Temp1 As Single
                        Temp1 = CSng(Bt1 * 256#)
                        DataVal = Bt2 + Temp1          ' Add LSByte to MSByte
        
                '--------------------------------------------------------------------------------------------------------------
                Case 4                                         ' Process as Floating Point data-type
                '--------------------------------------------------------------------------------------------------------------
                                                                ' Byte1 is Exponent
                                                                ' Byte2 is Mantissa MSByte
                                                                ' Byte3 is Mantissa LSByte
                        DataVal = Byte2Float(Bt1, Bt2, Bt3)
                
         End Select
         
         ProcRxData = DataVal
End Function

Public Sub TxDataRequest(Address As Single, Dtype As Integer)
    ' Send data request message to PIC
    Dim AddressPIC As Integer
    Dim PIC_Data As String                       ' String to clear out RxBuffer

    If CommsActive Then
            PIC_Data = frmTREND3.MSComm1.Input    ' Clear Rx buffer
                            ' Tx data request: FF, NOB, FCODE, ADDRESS
                            ' First adjust PIC target address if requesting Word data
                                If Dtype = 3 Then
                                    AddressPIC = Address + 1                  ' Point to LSB address for Word data
                                Else
                                    AddressPIC = Address
                                End If
                                ' Now transmit the data request message to PIC with a delay between bytes.
                                ' The delay is adjustable on-line for those situations where the PIC is very busy
                                ' and cannot handle bytes so fast. Also notice we use FCODE = 3 for all data
                                ' requests, meaning we get 3 databytes from PIC. This program must then sort
                                ' out which bytes to retain.
                                TxByte (255)             ' Send FF (message start)
                                TxByte (2)                ' Send NOB (Nr Of Bytes in rest of message)
                            
                            ' If PIC Register Address > FFh then set bit 8 in FCODE
                            ' byte. This will tell PIC that access is to 3rd or 4th Bank
                            ' and IRP bit should be set.
                            If AddressPIC > &HFF Then
                                TxByte (3 + 128)        ' Tx FCODE byte
                            Else
                                TxByte (3)                 ' Tx FCODE byte
                            End If
                           TxByte (AddressPIC And &HFF)   ' Send PIC register file address
    End If
End Sub
